// ia32dis.cpp : Defines the entry point for the DLL application.
//

#include "stdafx.h"
#include "ia32dis.h"
#include <stdio.h>

BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
	switch (ul_reason_for_call)
	{
	case DLL_PROCESS_ATTACH:
	case DLL_THREAD_ATTACH:
	case DLL_THREAD_DETACH:
	case DLL_PROCESS_DETACH:
	    break;
	}
	return TRUE;
}


// This is an example of an exported variable
IA32DIS_API int nIa32dis=0;

extern	"C" long disasm(unsigned char *data, char *output, int outbufsize, int segsize,
            long offset, int autosync, unsigned long prefer);

// This is an example of an exported function.
extern "C"
IA32DIS_API int ia32_disasm(unsigned char *inbuff, char *outbuff, int outsize, int segsize, long pc)
{
        return disasm(inbuff, outbuff, outsize, segsize, (long)pc, 0, 0);
}

// This is the constructor of a class that has been exported.
// see ia32dis.h for the class definition
CIa32dis::CIa32dis()
{
}

extern "C"
int	snprintf(char *dest, int len, const char *fmt, ...)
{
	int	res;
	va_list	ap;

	va_start(ap, fmt);
	res = _vsnprintf(dest, len, fmt, ap);
	va_end(ap);
	return res;
}
